#pragma once

#include <RobotAPI/libraries/armem/core/DataMode.h>
#include <RobotAPI/libraries/armem/client/query/Builder.h>

#include "SnapshotSelectorWidget.h"

class QWidget;
class QTabWidget;
class QPushButton;

namespace armarx::armem::gui
{

    class QueryWidget : public QWidget
    {
        Q_OBJECT
        using This = QueryWidget;

    public:

        QueryWidget();

        armem::DataMode dataMode() const;

        int queryLinkRecursionDepth() const;


    public slots:

    signals:
        void storeInLTM();

        // ToDo:
        // void queryChanged(armem::query::data::Input query);


    private slots:
        void setRecursionDepthSpinnerEnabled(int state);

    signals:



    private:

        QCheckBox* _dataCheckBox;
        QLabel* _recursionDepthLabel;
        QSpinBox* _recursionDepthSpinner;
        QPushButton* _storeInLTMButton;

    };

}
